Index: GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h	(revision 1078)
+++ GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshViewUI.h	(revision 1083)
@@ -372,7 +372,7 @@
 
 	//	Initialize the lodstripslibrary for visualization.
-	void	setLodStripsLibrary(const Geometry::LodStripsLibraryData &, Mesh	*geomesh);
+	void	setLodStripsLibrary(const Geometry::LodStripsLibraryData *, Mesh	*geomesh);
 	//	Initialize the lodtreelibrary for visualization.
-	void	setLodTreesLibrary(const Geometry::LodStripsLibraryData &, const Geometry::TreeSimplificationSequence &, Mesh	*geomesh, uint32 ileafSubMesh);
+	void	setLodTreesLibrary(const Geometry::LodStripsLibraryData *, const Geometry::TreeSimplificationSequence *, Mesh	*geomesh, uint32 ileafSubMesh);
 
 	// Indentify the mesh of leaves.
Index: GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshLoader.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshLoader.h	(revision 1078)
+++ 	(revision )
@@ -1,214 +1,0 @@
-/*	==========================================================================
- *	(C) 2005 Universitat Jaume I
- *	==========================================================================
- *	PROYECT:	GAME TOOLS
- *	==========================================================================
- *	CONTENT:	
- *
- *
- *	@file	GeoMeshLoader.h
- *===========================================================================*/
-#ifndef __GEO_MESH_LOADER__
-#define __GEO_MESH_LOADER__
-
-#include <stdio.h>
-#include <stdlib.h>
-#include <string>
-#include <vector>
-#include <memory.h>
-#include <time.h>
-#include <iostream>
-#include <iomanip>
-#include "GeoBase.h"
-#include "GeoMesh.h"
-#include "GeoLodStripsLibrary.h"
-#include "GeoLodTreeLibrary.h"
-
-namespace Geometry 
-{
-	const	unsigned	short	CHUNK_OVERHEAD_SIZE	= sizeof(unsigned short)
-																							+
-																							sizeof(unsigned long);
-
-	const unsigned	short M_HEADER											= 0x1000;
-	const unsigned	short M_MESH												= 0x3000;
-	const unsigned	short M_SUBMESH											= 0x4000; 
-	const unsigned	short M_SUBMESH_OPERATION						= 0x4010;
-	const unsigned	short M_SUBMESH_BONE_ASSIGNMENT			= 0x4100;
-	const unsigned	short M_GEOMETRY										= 0x5000;
-	const unsigned	short M_GEOMETRY_VERTEX_DECLARATION = 0x5100;
-	const unsigned	short M_GEOMETRY_VERTEX_ELEMENT			= 0x5110;
-	const unsigned	short M_GEOMETRY_VERTEX_BUFFER			= 0x5200;
-	const unsigned	short M_GEOMETRY_VERTEX_BUFFER_DATA = 0x5210;
-	const unsigned	short M_MESH_SKELETON_LINK					= 0x6000;
-	const unsigned	short M_MESH_BONE_ASSIGNMENT				= 0x7000;
-	const unsigned	short M_MESH_LOD										=	0x8000;
-	const unsigned	short M_MESH_LOD_USAGE							=	0x8100;
-	const unsigned	short M_MESH_LOD_MANUAL							=	0x8110;
-	const unsigned	short M_MESH_LOD_GENERATED					=	0x8120;
-	const unsigned	short M_MESH_BOUNDS									=	0x9000;
-	const unsigned	short M_SUBMESH_NAME_TABLE					=	0xA000;
-	const unsigned	short	M_SUBMESH_NAME_TABLE_ELEMENT	=	0xA100;
-	const unsigned	short M_EDGE_LISTS									=	0xB000;
-	const unsigned	short M_EDGE_LIST_LOD								=	0xB100;
-	const unsigned	short M_EDGE_GROUP									= 0xB110;
-	const	unsigned	short	SUBMESH_COUNT									=	0;
-	const	unsigned	short	GEOMESH_BUILD									=	1;
-	
-	enum VertexElementType
-	{
-		VET_FLOAT1,
-		VET_FLOAT2,
-		VET_FLOAT3,
-		VET_FLOAT4,
-		VET_COLOUR,
-		VET_SHORT1,
-		VET_SHORT2,
-		VET_SHORT3,
-		VET_SHORT4,
-		VET_UBYTE4
-	};
-
-	enum VertexElementSemantic
-	{
-		/// Position, 3 reals per vertex
-		VES_POSITION = 1,
-		/// Blending weights
-		VES_BLEND_WEIGHTS = 2,
-		/// Blending indices
-		VES_BLEND_INDICES = 3,
-		/// Normal, 3 reals per vertex
-		VES_NORMAL = 4,
-		/// Diffuse colours
-		VES_DIFFUSE = 5,
-		/// Specular colours
-		VES_SPECULAR = 6,
-		/// Texture coordinates
-		VES_TEXTURE_COORDINATES = 7,
-		/// Binormal (Y axis if normal is Z)
-		VES_BINORMAL = 8,
-		/// Tangent (X axis if normal is Z)
-		VES_TANGENT = 9
-	};
-
-	/*
-	//	Bounding Box data.
-	struct	GeometryBounds
-	{
-		float	minx;
-		float	miny;
-		float	minz;
-		float	maxx;
-		float	maxy;
-		float	maxz;
-		float	radius;
-	};
-	*/
-	
-	/// Mesh class interface
-	class GeoMeshLoader
-	{
-		private:
-			
-			Mesh						*geoMesh;
-			size_t					mFileSize;
-			unsigned	int		numVertices;
-			unsigned	long	long_actual;
-			size_t					currentSubMesh;
-			bool						mError;
-
-			struct GeometryElement
-			{
-				unsigned short offset;
-				unsigned short semantic;
-				unsigned short type;
-				unsigned short index;
-			};
-
-			struct GT
-			{
-				unsigned short source; //bindIndex
-				std::vector <GeometryElement> list;
-			};
-
-			std::vector <GT> list;
-
-			//	Jump a chunk.
-			void jumpChunk(FILE	*f);
-
-			//	Read a chunk.
-			unsigned short readChunk(FILE	*f);
-
-			//	Read geometry vertex element.
-			void readGeometryVertexElement(FILE	*f, Mesh	*geoMesh);
-
-			//	Read geometry vertex declaration.
-			void readGeometryVertexDeclaration(FILE	*f, Mesh	*geoMesh);
-
-			//	Read geometry vertex buffer.
-			void readGeometryVertexBuffer(FILE		*f,
-																		Mesh		*geoMesh,
-																		int 		option);
-
-			//	Read geometry.
-			void readGeometry(FILE	*f, Mesh	*geoMesh, int option);
-
-			//	Read a submesh operation.
-			void readSubMeshOperation(FILE	*f, Mesh	*geoMesh, int option);
-
-			//	Read a submesh.
-			void readSubMesh(FILE	*f, Mesh	*geoMesh, int option);
-
-			//	Read skeleton name.
-			void readSkeletonLink(FILE	*f, Mesh	*geoMesh, int option);
-
-			//	Read bone assignment.
-			void readMeshBoneAssignment(FILE	*f, Mesh	*geoMesh, int option);
-
-			//	Read bone assignment.
-			void readSubMeshBoneAssignment(FILE	*f, SubMesh	*geoSubMesh, int option);
-
-			//	Read a mesh lod information.
-			void readMeshLodInfo(FILE	*f, Mesh	*geoMesh);
-
-			//	Read a submesh name table.
-			void readSubMeshNameTable(FILE	*f, Mesh	*geoMesh);
-
-			//	Read a mesh file.
-			void readMesh(FILE	*f, Mesh	*geoMesh, int option);
-
-			//	Read bounding box settings.
-			void	readMeshBounds(FILE	*f, Mesh	*geoMesh,	int	option);
-
-			//	Writes the strips list.
-			SubMesh* GeoMeshLoader::BuildStripsGeoSubMesh(SubMesh	*geoSubMesh);
-
-			//	Remove degenerate triangles of a submesh given.
-			SubMesh	*	removeDegenerateTriangles(SubMesh	*geoSubMesh);
-			
-			//	Sets coods between -1 and 1.
-			void	normalizeModel(Mesh	*geoMesh);
-
-			// Imports an OBJ object
-			void importOBJ(FILE *f, Mesh *geoMesh);
-
-		public:
-
-			//	Constructor.
-			GeoMeshLoader();
-
-			//	Destroyer.
-			~GeoMeshLoader();
-
-			//	Loads a Mesh file.
-			Mesh* load(char	*fileNameMesh);
-
-			//	Get the size in bytes of the file.
-			size_t	getFileSize();
-
-			Geometry::LodStripsLibraryData lodstripsdata;
-			Geometry::TreeSimplificationSequence treesimpseq;
-	};
-}
-#endif
-
Index: GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshSaver.h
===================================================================
--- GTP/trunk/Lib/Geom/shared/GeoTool/include/GeoMeshSaver.h	(revision 1017)
+++ 	(revision )
@@ -1,124 +1,0 @@
-/*	==========================================================================
- *	(C) 2005 Universitat Jaume I
- *	==========================================================================
- *	PROYECT:	GAME TOOLS
- *	========================================================================*/
-/*	CONTENT:	
- *
- *
- *	@file	GeoMeshSaver.h
- *	========================================================================*/
-
-#ifndef	__GEO_MESH_SAVER__
-#define	__GEO_MESH_SAVER__
-
-#include	<GeoMeshLoader.h>
-
-namespace Geometry 
-{
-	//	Saves a Mesh.
-	class	GeoMeshSaver
-	{
-		private:
-			//	The mesh to write.
-			Mesh	*mGeoMesh;
-			
-			//	Mesh Bounds.
-			//GeometryBounds	mMeshBounds;
-			
-			//	Write in the file.
-			Serializer	*mSerializer;
-
-			//	Flag that indicate if the mesh 
-			//	is skeletally animated or not.
-			bool	mSkeletallyAnimated;
-			
-			//	Write the main mesh.
-			void	writeMesh(Mesh	*geoMesh);
-
-			//	Write a submesh.
-			void	writeSubMesh(SubMesh	*geoSubMesh);
-
-			// Operation type
-			void	writeSubMeshOperation(const	SubMesh	*geoSubMesh);
-			
-			//	Write geometry.
-			void	writeGeometry(VertexBuffer	*vertexBuffer);
-
-			//	Write Mesh Bounds.
-			void	writeMeshBounds(Mesh	*geoMesh);
-			
-			//	Calculate the mesh size in bytes.
-			size_t	calcMeshSize(const Mesh	*geoMesh);
-
-			//	Calculate the size in bytes for the submesh.
-			size_t	calcSubMeshSize(const SubMesh	*geoSubMesh);
-
-			//	Calculate the geometry size in bytes.
-			size_t	calcGeometrySize(const VertexBuffer* vertexBuffer);
-
-			//	Calculate the skeleton link size in bytes.
-			size_t	calcSkeletonLinkSize(const Mesh	*geoMesh);
-
-			//	Write the file header.
-			void	writeFileHeader(void);
-
-			//	Write a header chunk given.
-			void	writeChunkHeader(	unsigned short	id,
-															unsigned long		count);
-
-			//	Write integers into the file.
-			void	writeInts(unsigned long	id,
-											unsigned long	size);
-
-			//	Write shorts into the file
-			void	writeShorts(unsigned short	id,
-												unsigned long		count);
-
-			//	Write float into the file.
-			void	writeFloats(float						id,
-												unsigned long		count);
-
-			//	Write a string into the file.
-			void	writeString(const	String	&string);
-
-			//	Write booleans into the file.
-			void	writeBools(	const bool id,
-												unsigned	long		count);
-
-			//	Write skeleton name.
-			void	writeSkeletonLink(const	String	&string);
-
-			void	writeMeshBoneAssignment(const VertexBoneAssignment& assign);
-
-			void	writeSubMeshBoneAssignment(const VertexBoneAssignment& assign);
-
-			//	unnormalize geometry model.
-			void	unnormalizeModel(Mesh	*geoMesh);
-			
-		public:
-
-			//	Constructors.
-			GeoMeshSaver();
-
-			//	Destroyer.
-			~GeoMeshSaver();
-
-			//	Sets the material of the mesh.
-			void	setMaterialName(String	materialName);
-
-			//	Gets the material of the mesh.
-			String	getMaterialName();
-			
-			//	Saves a Mesh into a file.
-			int	save(Mesh	*geoMesh,	const	char	*fileNameMesh);
-
-			// temporal members used to tweak the lodtree leaf submesh
-			int leavesSubMesh;
-			VertexBuffer *leavesVB;
-			Index *indices;
-			int numindices;
-	};
-}
-#endif
-