Index: GTP/trunk/Lib/Vis/Preprocessing/scripts/Preprocessor.vcproj
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/scripts/Preprocessor.vcproj	(revision 1097)
+++ GTP/trunk/Lib/Vis/Preprocessing/scripts/Preprocessor.vcproj	(revision 1099)
@@ -158,4 +158,7 @@
 			</File>
 			<File
+				RelativePath="..\src\FlexibleHeap.h">
+			</File>
+			<File
 				RelativePath="..\src\glInterface.h">
 			</File>
@@ -502,263 +505,4 @@
 				RelativePath="..\src\X3dParserXerces.h">
 			</File>
-			<Filter
-				Name="mixkit"
-				Filter="">
-				<File
-					RelativePath="..\src\mixkit\getopt.c">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\getopt.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\getopt1.c">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\mixio.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\mixmops.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\mixmops.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\mixmsg.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\mixmsg.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\mixvops.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxArcball.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxArcball.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxAsp.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxAsp.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxBlock.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxBlock2.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxBlock3.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxBlockModel.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxBlockModel.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxCamera.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxCamera.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxCmdParser.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxCmdParser.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxDynBlock.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxEdgeFilter.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxEdgeFilter.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxGeom3D.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxGeom3D.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxGeoPrims.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxGL.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxGLDebug.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxGLPane.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxGLPane.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxGLUtils.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxGLUtils.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxHeap.cxx">
-					<FileConfiguration
-						Name="Debug|Win32">
-						<Tool
-							Name="VCCLCompilerTool"
-							ObjectFile="$(IntDir)/$(InputName)1.obj"/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32">
-						<Tool
-							Name="VCCLCompilerTool"
-							ObjectFile="$(IntDir)/$(InputName)1.obj"/>
-					</FileConfiguration>
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxHeap.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxLineModel.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxManipulator.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxMat2.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxMat2.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxMat3-jacobi.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxMat3.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxMat3.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxMat4-jacobi.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxMat4.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxMat4.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxMath.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxMatrix.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxMatrix.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxPropSlim.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxPropSlim.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxQMetric.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxQMetric.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxQMetric2.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxQMetric2.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxQMetric3.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxQMetric3.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxQSlim.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxQSlim.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxQVis3.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxRaster-tiff.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxRaster.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxRaster.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxSMF.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxSMF.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxStack.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxStdModel.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxStdModel.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxStdPane.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxStdPane.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxStdRender.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxStdSlim.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxStdSlim.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxTimer.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxTimer.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxTriProject.cxx">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxVec2.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxVec3.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxVec4.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\MxVector.h">
-				</File>
-				<File
-					RelativePath="..\src\mixkit\stdmix.h">
-				</File>
-			</Filter>
 		</Filter>
 		<Filter
@@ -798,4 +542,263 @@
 			<File
 				RelativePath="..\include\ViewCell.h">
+			</File>
+		</Filter>
+		<Filter
+			Name="mixkit"
+			Filter="">
+			<File
+				RelativePath="..\src\mixkit\getopt.c">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\getopt.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\getopt1.c">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\mixio.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\mixmops.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\mixmops.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\mixmsg.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\mixmsg.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\mixvops.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxArcball.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxArcball.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxAsp.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxAsp.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxBlock.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxBlock2.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxBlock3.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxBlockModel.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxBlockModel.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxCamera.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxCamera.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxCmdParser.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxCmdParser.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxDynBlock.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxEdgeFilter.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxEdgeFilter.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxGeom3D.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxGeom3D.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxGeoPrims.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxGL.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxGLDebug.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxGLPane.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxGLPane.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxGLUtils.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxGLUtils.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxHeap.cxx">
+				<FileConfiguration
+					Name="Debug|Win32">
+					<Tool
+						Name="VCCLCompilerTool"
+						ObjectFile="$(IntDir)/$(InputName)1.obj"/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Release|Win32">
+					<Tool
+						Name="VCCLCompilerTool"
+						ObjectFile="$(IntDir)/$(InputName)1.obj"/>
+				</FileConfiguration>
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxHeap.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxLineModel.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxManipulator.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxMat2.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxMat2.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxMat3-jacobi.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxMat3.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxMat3.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxMat4-jacobi.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxMat4.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxMat4.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxMath.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxMatrix.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxMatrix.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxPropSlim.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxPropSlim.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxQMetric.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxQMetric.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxQMetric2.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxQMetric2.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxQMetric3.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxQMetric3.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxQSlim.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxQSlim.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxQVis3.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxRaster-tiff.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxRaster.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxRaster.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxSMF.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxSMF.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxStack.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxStdModel.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxStdModel.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxStdPane.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxStdPane.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxStdRender.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxStdSlim.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxStdSlim.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxTimer.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxTimer.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxTriProject.cxx">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxVec2.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxVec3.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxVec4.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\MxVector.h">
+			</File>
+			<File
+				RelativePath="..\src\mixkit\stdmix.h">
 			</File>
 		</Filter>